diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/eht-phy.h ns-3.44/src/wifi/model/eht/eht-phy.h
--- ns-3.43/src/wifi/model/eht/eht-phy.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/eht-phy.h	2025-03-09 16:55:49.787372600 -0700
@@ -12,8 +12,8 @@
 #include "ns3/he-phy.h"
 
 /**
- * \file
- * \ingroup wifi
+ * @file
+ * @ingroup wifi
  * Declaration of ns3::EhtPhy class.
  */
 
@@ -26,8 +26,8 @@
 #define EHT_PHY 121 // FIXME: not defined yet as of 802.11be D1.5
 
 /**
- * \brief PHY entity for EHT (11be)
- * \ingroup wifi
+ * @brief PHY entity for EHT (11be)
+ * @ingroup wifi
  *
  * EHT PHY is based on HE PHY.
  *
@@ -39,7 +39,7 @@
     /**
      * Constructor for EHT PHY
      *
-     * \param buildModeList flag used to add EHT modes to list (disabled
+     * @param buildModeList flag used to add EHT modes to list (disabled
      *                      by child classes to only add child classes' modes)
      */
     EhtPhy(bool buildModeList = true);
@@ -64,93 +64,93 @@
      * Return the EHT MCS corresponding to
      * the provided index.
      *
-     * \param index the index of the MCS
-     * \return an EHT MCS
+     * @param index the index of the MCS
+     * @return an EHT MCS
      */
     static WifiMode GetEhtMcs(uint8_t index);
 
     /**
      * Return MCS 0 from EHT MCS values.
      *
-     * \return MCS 0 from EHT MCS values
+     * @return MCS 0 from EHT MCS values
      */
     static WifiMode GetEhtMcs0();
     /**
      * Return MCS 1 from EHT MCS values.
      *
-     * \return MCS 1 from EHT MCS values
+     * @return MCS 1 from EHT MCS values
      */
     static WifiMode GetEhtMcs1();
     /**
      * Return MCS 2 from EHT MCS values.
      *
-     * \return MCS 2 from EHT MCS values
+     * @return MCS 2 from EHT MCS values
      */
     static WifiMode GetEhtMcs2();
     /**
      * Return MCS 3 from EHT MCS values.
      *
-     * \return MCS 3 from EHT MCS values
+     * @return MCS 3 from EHT MCS values
      */
     static WifiMode GetEhtMcs3();
     /**
      * Return MCS 4 from EHT MCS values.
      *
-     * \return MCS 4 from EHT MCS values
+     * @return MCS 4 from EHT MCS values
      */
     static WifiMode GetEhtMcs4();
     /**
      * Return MCS 5 from EHT MCS values.
      *
-     * \return MCS 5 from EHT MCS values
+     * @return MCS 5 from EHT MCS values
      */
     static WifiMode GetEhtMcs5();
     /**
      * Return MCS 6 from EHT MCS values.
      *
-     * \return MCS 6 from EHT MCS values
+     * @return MCS 6 from EHT MCS values
      */
     static WifiMode GetEhtMcs6();
     /**
      * Return MCS 7 from EHT MCS values.
      *
-     * \return MCS 7 from EHT MCS values
+     * @return MCS 7 from EHT MCS values
      */
     static WifiMode GetEhtMcs7();
     /**
      * Return MCS 8 from EHT MCS values.
      *
-     * \return MCS 8 from EHT MCS values
+     * @return MCS 8 from EHT MCS values
      */
     static WifiMode GetEhtMcs8();
     /**
      * Return MCS 9 from EHT MCS values.
      *
-     * \return MCS 9 from EHT MCS values
+     * @return MCS 9 from EHT MCS values
      */
     static WifiMode GetEhtMcs9();
     /**
      * Return MCS 10 from EHT MCS values.
      *
-     * \return MCS 10 from EHT MCS values
+     * @return MCS 10 from EHT MCS values
      */
     static WifiMode GetEhtMcs10();
     /**
      * Return MCS 11 from EHT MCS values.
      *
-     * \return MCS 11 from EHT MCS values
+     * @return MCS 11 from EHT MCS values
      */
     static WifiMode GetEhtMcs11();
     /**
      * Return MCS 12 from EHT MCS values.
      *
-     * \return MCS 12 from EHT MCS values
+     * @return MCS 12 from EHT MCS values
      */
     static WifiMode GetEhtMcs12();
     /**
      * Return MCS 13 from EHT MCS values.
      *
-     * \return MCS 13 from EHT MCS values
+     * @return MCS 13 from EHT MCS values
      */
     static WifiMode GetEhtMcs13();
 
@@ -159,8 +159,8 @@
      * the supplied EHT MCS index. This function is used
      * as a callback for WifiMode operation.
      *
-     * \param mcsValue the MCS index
-     * \return the coding rate.
+     * @param mcsValue the MCS index
+     * @return the coding rate.
      */
     static WifiCodeRate GetCodeRate(uint8_t mcsValue);
 
@@ -169,8 +169,8 @@
      * to the supplied EHT MCS index. This function is used
      * as a callback for WifiMode operation.
      *
-     * \param mcsValue the MCS index
-     * \return the size of modulation constellation.
+     * @param mcsValue the MCS index
+     * @return the size of modulation constellation.
      */
     static uint16_t GetConstellationSize(uint8_t mcsValue);
 
@@ -180,12 +180,12 @@
      * spatial stream. This function calls HtPhy::CalculatePhyRate
      * and is mainly used as a callback for WifiMode operation.
      *
-     * \param mcsValue the EHT MCS index
-     * \param channelWidth the considered channel width
-     * \param guardInterval the considered guard interval duration
-     * \param nss the considered number of stream
+     * @param mcsValue the EHT MCS index
+     * @param channelWidth the considered channel width
+     * @param guardInterval the considered guard interval duration
+     * @param nss the considered number of stream
      *
-     * \return the physical bit rate of this signal in bps.
+     * @return the physical bit rate of this signal in bps.
      */
     static uint64_t GetPhyRate(uint8_t mcsValue,
                                MHz_u channelWidth,
@@ -196,9 +196,9 @@
      * Return the PHY rate corresponding to
      * the supplied TXVECTOR for the STA-ID.
      *
-     * \param txVector the TXVECTOR used for the transmission
-     * \param staId the station ID for MU (unused if SU)
-     * \return the physical bit rate of this signal in bps.
+     * @param txVector the TXVECTOR used for the transmission
+     * @param staId the station ID for MU (unused if SU)
+     * @return the physical bit rate of this signal in bps.
      */
     static uint64_t GetPhyRateFromTxVector(const WifiTxVector& txVector,
                                            uint16_t staId = SU_STA_ID);
@@ -207,9 +207,9 @@
      * Return the data rate corresponding to
      * the supplied TXVECTOR for the STA-ID.
      *
-     * \param txVector the TXVECTOR used for the transmission
-     * \param staId the station ID for MU (unused if SU)
-     * \return the data bit rate in bps.
+     * @param txVector the TXVECTOR used for the transmission
+     * @param staId the station ID for MU (unused if SU)
+     * @return the data bit rate in bps.
      */
     static uint64_t GetDataRateFromTxVector(const WifiTxVector& txVector,
                                             uint16_t staId = SU_STA_ID);
@@ -220,11 +220,11 @@
      * guard interval, and number of spatial
      * streams.
      *
-     * \param mcsValue the EHT MCS index
-     * \param channelWidth the channel width
-     * \param guardInterval the guard interval duration
-     * \param nss the number of spatial streams
-     * \return the data bit rate in bps.
+     * @param mcsValue the EHT MCS index
+     * @param channelWidth the channel width
+     * @param guardInterval the guard interval duration
+     * @param nss the number of spatial streams
+     * @return the data bit rate in bps.
      */
     static uint64_t GetDataRate(uint8_t mcsValue,
                                 MHz_u channelWidth,
@@ -236,8 +236,8 @@
      * to the supplied HE MCS index. This function calls CalculateNonHtReferenceRate
      * and is used as a callback for WifiMode operation.
      *
-     * \param mcsValue the HE MCS index
-     * \return the rate in bps of the non-HT Reference Rate.
+     * @param mcsValue the HE MCS index
+     * @return the rate in bps of the non-HT Reference Rate.
      */
     static uint64_t GetNonHtReferenceRate(uint8_t mcsValue);
 
@@ -258,8 +258,8 @@
      * the provided index.
      * This method binds all the callbacks used by WifiMode.
      *
-     * \param index the index of the MCS
-     * \return an EHT MCS
+     * @param index the index of the MCS
+     * @return an EHT MCS
      */
     static WifiMode CreateEhtMcs(uint8_t index);
 
@@ -268,9 +268,9 @@
      * which corresponds to the supplied code rate and
      * constellation size.
      *
-     * \param codeRate the convolutional coding rate
-     * \param constellationSize the size of modulation constellation
-     * \returns the rate in bps.
+     * @param codeRate the convolutional coding rate
+     * @param constellationSize the size of modulation constellation
+     * @returns the rate in bps.
      *
      * To convert an HE MCS to its corresponding non-HT Reference Rate
      * use the modulation and coding rate of the HT MCS
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/eht-ppdu.cc ns-3.44/src/wifi/model/eht/eht-ppdu.cc
--- ns-3.43/src/wifi/model/eht/eht-ppdu.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/eht-ppdu.cc	2025-03-09 16:55:49.787372600 -0700
@@ -14,6 +14,7 @@
 #include "ns3/wifi-phy-operating-channel.h"
 #include "ns3/wifi-psdu.h"
 
+#include <algorithm>
 #include <numeric>
 
 namespace ns3
@@ -47,11 +48,19 @@
     NS_ASSERT(bssColor < 64);
     if (ns3::IsDlMu(m_preamble))
     {
-        const auto p20Index = m_operatingChannel.GetPrimaryChannelIndex(20);
+        const auto p20Index = m_operatingChannel.GetPrimaryChannelIndex(MHz_u{20});
         m_ehtPhyHeader.emplace<EhtMuPhyHeader>(EhtMuPhyHeader{
             .m_bandwidth = GetChannelWidthEncodingFromMhz(txVector.GetChannelWidth()),
             .m_bssColor = bssColor,
             .m_ppduType = txVector.GetEhtPpduType(),
+            // TODO: EHT PPDU should store U-SIG per 20 MHz band, assume it is the lowest 20 MHz
+            // band for now
+            .m_puncturedChannelInfo =
+                GetPuncturedInfo(txVector.GetInactiveSubchannels(),
+                                 txVector.GetEhtPpduType(),
+                                 (txVector.IsDlMu() && (txVector.GetChannelWidth() > MHz_u{80}))
+                                     ? std::optional{true}
+                                     : std::nullopt),
             .m_ehtSigMcs = txVector.GetSigBMode().GetMcsValue(),
             .m_giLtfSize = GetGuardIntervalAndNltfEncoding(txVector.GetGuardInterval(),
                                                            2 /*NLTF currently unused*/),
@@ -115,14 +124,19 @@
     {
         auto ehtPhyHeader = std::get_if<EhtMuPhyHeader>(&m_ehtPhyHeader);
         NS_ASSERT(ehtPhyHeader);
-        txVector.SetChannelWidth(GetChannelWidthMhzFromEncoding(ehtPhyHeader->m_bandwidth));
+        const auto bw = GetChannelWidthMhzFromEncoding(ehtPhyHeader->m_bandwidth);
+        txVector.SetChannelWidth(bw);
         txVector.SetBssColor(ehtPhyHeader->m_bssColor);
         txVector.SetEhtPpduType(ehtPhyHeader->m_ppduType);
+        if (bw > MHz_u{80})
+        {
+            // TODO: use punctured channel information
+        }
         txVector.SetSigBMode(HePhy::GetVhtMcs(ehtPhyHeader->m_ehtSigMcs));
         txVector.SetGuardInterval(GetGuardIntervalFromEncoding(ehtPhyHeader->m_giLtfSize));
         const auto ruAllocation = ehtPhyHeader->m_ruAllocationA; // RU Allocation-B not supported
                                                                  // yet
-        if (const auto p20Index = m_operatingChannel.GetPrimaryChannelIndex(20);
+        if (const auto p20Index = m_operatingChannel.GetPrimaryChannelIndex(MHz_u{20});
             ruAllocation.has_value())
         {
             txVector.SetRuAllocation(ruAllocation.value(), p20Index);
@@ -200,14 +214,15 @@
     if (!compression)
     {
         commonFieldSize = 4 /* CRC */ + 6 /* tail */;
-        if (channelWidth <= 40)
+        if (channelWidth <= MHz_u{40})
         {
             commonFieldSize += 8; // only one allocation subfield
         }
         else
         {
             commonFieldSize +=
-                8 * (channelWidth / 40) /* one allocation field per 40 MHz */ + 1 /* center RU */;
+                8 * (channelWidth / MHz_u{40}) /* one allocation field per 40 MHz */ +
+                1 /* center RU */;
         }
     }
 
@@ -230,6 +245,63 @@
     return commonFieldSize + userSpecificFieldSize;
 }
 
+uint8_t
+EhtPpdu::GetPuncturedInfo(const std::vector<bool>& inactiveSubchannels,
+                          uint8_t ehtPpduType,
+                          std::optional<bool> isLow80MHz)
+{
+    if (inactiveSubchannels.size() < 4)
+    {
+        // no puncturing if less than 80 MHz
+        return 0;
+    }
+    NS_ASSERT_MSG(inactiveSubchannels.size() <= 8,
+                  "Puncturing over more than 160 MHz is not supported");
+    if (ehtPpduType == 0)
+    {
+        // IEEE 802.11be D5.0 Table 36-28
+        NS_ASSERT(inactiveSubchannels.size() <= 4 || isLow80MHz.has_value());
+        const auto startIndex = (inactiveSubchannels.size() <= 4) ? 0 : (*isLow80MHz ? 0 : 4);
+        const auto stopIndex =
+            (inactiveSubchannels.size() <= 4) ? inactiveSubchannels.size() : (*isLow80MHz ? 4 : 8);
+        uint8_t puncturedInfoField = 0;
+        for (std::size_t i = startIndex; i < stopIndex; ++i)
+        {
+            if (!inactiveSubchannels.at(i))
+            {
+                puncturedInfoField |= 1 << (i / 4);
+            }
+        }
+        return puncturedInfoField;
+    }
+    // IEEE 802.11be D5.0 Table 36-30
+    const auto numPunctured = std::count_if(inactiveSubchannels.cbegin(),
+                                            inactiveSubchannels.cend(),
+                                            [](bool punctured) { return punctured; });
+    if (numPunctured == 0)
+    {
+        // no puncturing
+        return 0;
+    }
+    const auto firstPunctured = std::find_if(inactiveSubchannels.cbegin(),
+                                             inactiveSubchannels.cend(),
+                                             [](bool punctured) { return punctured; });
+    const auto firstIndex = std::distance(inactiveSubchannels.cbegin(), firstPunctured);
+    switch (numPunctured)
+    {
+    case 1:
+        return firstIndex + 1;
+    case 2:
+        NS_ASSERT_MSG(((firstIndex % 2) == 0) && inactiveSubchannels.at(firstIndex + 1),
+                      "invalid 40 MHz puncturing pattern");
+        return 9 + (firstIndex / 2);
+    default:
+        break;
+    }
+    NS_ASSERT_MSG(false, "invalid puncturing pattern");
+    return 0;
+}
+
 Ptr<WifiPpdu>
 EhtPpdu::Copy() const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/eht-ppdu.h ns-3.44/src/wifi/model/eht/eht-ppdu.h
--- ns-3.43/src/wifi/model/eht/eht-ppdu.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/eht-ppdu.h	2025-03-09 16:55:49.787372600 -0700
@@ -14,8 +14,8 @@
 #include <optional>
 
 /**
- * \file
- * \ingroup wifi
+ * @file
+ * @ingroup wifi
  * Declaration of ns3::EhtPpdu class.
  */
 
@@ -23,8 +23,8 @@
 {
 
 /**
- * \brief EHT PPDU (11be)
- * \ingroup wifi
+ * @brief EHT PPDU (11be)
+ * @ingroup wifi
  *
  * EhtPpdu is currently identical to HePpdu
  */
@@ -37,12 +37,11 @@
     struct EhtTbPhyHeader
     {
         // U-SIG fields
-        uint8_t m_phyVersionId{0}; ///< PHY Version Identifier field
-        uint8_t m_bandwidth{0};    ///< Bandwidth field
-        uint8_t m_bssColor{0};     ///< BSS color field
-        uint8_t m_ppduType{0};     ///< PPDU Type And Compressed Mode field
-
-    }; // struct EhtTbPhyHeader
+        uint8_t m_phyVersionId : 3 {0}; ///< PHY Version Identifier field
+        uint8_t m_bandwidth : 3 {0};    ///< Bandwidth field
+        uint8_t m_bssColor : 6 {0};     ///< BSS color field
+        uint8_t m_ppduType : 2 {0};     ///< PPDU Type And Compressed Mode field
+    };                                  // struct EhtTbPhyHeader
 
     /**
      * PHY header for EHT MU PPDUs
@@ -50,11 +49,12 @@
     struct EhtMuPhyHeader
     {
         // U-SIG fields
-        uint8_t m_phyVersionId{0}; ///< PHY Version Identifier field
-        uint8_t m_bandwidth{0};    ///< Bandwidth field
-        uint8_t m_bssColor{0};     ///< BSS color field
-        uint8_t m_ppduType{0};     ///< PPDU Type And Compressed Mode field
-        uint8_t m_ehtSigMcs{0};    ///< EHT-SIG-B MCS
+        uint8_t m_phyVersionId : 3 {0};         ///< PHY Version Identifier field
+        uint8_t m_bandwidth : 3 {0};            ///< Bandwidth field
+        uint8_t m_bssColor : 6 {0};             ///< BSS color field
+        uint8_t m_ppduType : 2 {0};             ///< PPDU Type And Compressed Mode field
+        uint8_t m_puncturedChannelInfo : 5 {0}; ///< Punctured Channel Information field
+        uint8_t m_ehtSigMcs : 2 {0};            ///< EHT-SIG-B MCS
 
         // EHT-SIG fields
         uint8_t m_giLtfSize{0}; ///< GI+LTF Size field
@@ -75,12 +75,12 @@
      *
      * This PPDU can either be UL or DL.
      *
-     * \param psdus the PHY payloads (PSDUs)
-     * \param txVector the TXVECTOR that was used for this PPDU
-     * \param channel the operating channel of the PHY used to transmit this PPDU
-     * \param ppduDuration the transmission duration of this PPDU
-     * \param uid the unique ID of this PPDU or of the triggering PPDU if this is an EHT TB PPDU
-     * \param flag the flag indicating the type of Tx PSD to build
+     * @param psdus the PHY payloads (PSDUs)
+     * @param txVector the TXVECTOR that was used for this PPDU
+     * @param channel the operating channel of the PHY used to transmit this PPDU
+     * @param ppduDuration the transmission duration of this PPDU
+     * @param uid the unique ID of this PPDU or of the triggering PPDU if this is an EHT TB PPDU
+     * @param flag the flag indicating the type of Tx PSD to build
      */
     EhtPpdu(const WifiConstPsduMap& psdus,
             const WifiTxVector& txVector,
@@ -96,17 +96,17 @@
      * Get the number of RUs per EHT-SIG-B content channel.
      * This function will be used once EHT PHY headers are implemented.
      *
-     * \param channelWidth the channel width occupied by the PPDU
-     * \param ehtPpduType the EHT_PPDU_TYPE used by the PPDU
-     * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
-     * \param compression flag whether compression mode is used by the PPDU
-     * \param numMuMimoUsers the number of MU-MIMO users addressed by the PPDU
-     * \return a pair containing the number of RUs in each EHT-SIG-B content channel (resp. 1 and 2)
+     * @param channelWidth the channel width occupied by the PPDU
+     * @param ehtPpduType the EHT_PPDU_TYPE used by the PPDU
+     * @param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
+     * @param compression flag whether compression mode is used by the PPDU
+     * @param numMuMimoUsers the number of MU-MIMO users addressed by the PPDU
+     * @return a pair containing the number of RUs in each EHT-SIG-B content channel (resp. 1 and 2)
      */
     static std::pair<std::size_t, std::size_t> GetNumRusPerEhtSigBContentChannel(
         MHz_u channelWidth,
         uint8_t ehtPpduType,
-        const std::vector<uint8_t>& ruAllocation,
+        const RuAllocation& ruAllocation,
         bool compression,
         std::size_t numMuMimoUsers);
 
@@ -114,28 +114,42 @@
      * Get the EHT-SIG content channels for a given PPDU
      * IEEE 802.11be-D3.1 36.3.12.8.2 EHT-SIG content channels
      *
-     * \param txVector the TXVECTOR used for the PPDU
-     * \param p20Index the index of the primary20 channel
-     * \return EHT-SIG content channels
+     * @param txVector the TXVECTOR used for the PPDU
+     * @param p20Index the index of the primary20 channel
+     * @return EHT-SIG content channels
      */
     static HeSigBContentChannels GetEhtSigContentChannels(const WifiTxVector& txVector,
                                                           uint8_t p20Index);
 
     /**
      * Get variable length EHT-SIG field size
-     * \param channelWidth the channel width occupied by the PPDU
-     * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
-     * \param ehtPpduType the EHT_PPDU_TYPE used by the PPDU
-     * \param compression flag whether compression mode is used by the PPDU
-     * \param numMuMimoUsers the number of MU-MIMO users addressed by the PPDU
-     * \return field size in bytes
+     * @param channelWidth the channel width occupied by the PPDU
+     * @param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
+     * @param ehtPpduType the EHT_PPDU_TYPE used by the PPDU
+     * @param compression flag whether compression mode is used by the PPDU
+     * @param numMuMimoUsers the number of MU-MIMO users addressed by the PPDU
+     * @return field size in bytes
      */
     static uint32_t GetEhtSigFieldSize(MHz_u channelWidth,
-                                       const std::vector<uint8_t>& ruAllocation,
+                                       const RuAllocation& ruAllocation,
                                        uint8_t ehtPpduType,
                                        bool compression,
                                        std::size_t numMuMimoUsers);
 
+    /**
+     * Get the Punctured Channel Information field in the U-SIG
+     * @param inactiveSubchannels the bitmap indexed by the 20 MHz subchannels in ascending order,
+     * where each bit indicates whether the corresponding 20 MHz subchannel is punctured or not
+     * within the transmission bandwidth
+     * @param ehtPpduType the EHT_PPDU_TYPE used by the PPDU
+     * @param isLow80MHz flag whether the 80 MHz frequency subblock where U-SIG processing is
+     * performed is the lowest in frequency (if OFDMA and if channel width is larger than 80 MHz)
+     * @return the value of the Punctured Channel Information field
+     */
+    static uint8_t GetPuncturedInfo(const std::vector<bool>& inactiveSubchannels,
+                                    uint8_t ehtPpduType,
+                                    std::optional<bool> isLow80MHz);
+
   private:
     bool IsDlMu() const override;
     bool IsUlMu() const override;
@@ -144,15 +158,15 @@
     /**
      * Fill in the PHY headers.
      *
-     * \param txVector the TXVECTOR that was used for this PPDU
-     * \param ppduDuration the transmission duration of this PPDU
+     * @param txVector the TXVECTOR that was used for this PPDU
+     * @param ppduDuration the transmission duration of this PPDU
      */
     void SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration);
 
     /**
      * Fill in the EHT PHY header.
      *
-     * \param txVector the TXVECTOR that was used for this PPDU
+     * @param txVector the TXVECTOR that was used for this PPDU
      */
     void SetEhtPhyHeader(const WifiTxVector& txVector);
 
